=== tests/backend/CMakeLists.txt ===
add_subdirectory(Column)
add_subdirectory(Parser)
add_subdirectory(Range)
add_subdirectory(TextLabel)
add_subdirectory(XYCurve)
add_subdirectory(Axis)
add_subdirectory(Retransform)
add_subdirectory(BarPlot)
add_subdirectory(Datapicker)
add_subdirectory(Worksheet)
