=== debian/changelog ===
labplot (2.10.1-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:48:38 +1100

labplot (2.10.1-2build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:33:00 +0000

labplot (2.10.1-2build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:58:39 +0000

labplot (2.10.1-2) unstable; urgency=medium

  * Add the libqt5qxlsx-dev build dependency to use the external QXlsx library,
    instead of the embedded copy
    - drop the qtbase5-private-dev build dependency, no more needed now

 -- Pino Toscano <pino@debian.org>  Tue, 14 Nov 2023 06:41:07 +0100

labplot (2.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix the /usr/share/doc/labplot/examples symlink. (Closes: #1040560)
  * Remove an obsolete maintscript entry.
  * Stop using libcantor on mipsel, as libcantor uses qtwebengine which will be
    soon dropped from mipsel.

 -- Pino Toscano <pino@debian.org>  Sun, 16 Jul 2023 19:44:14 +0200
